# coding: utf-8

"""
    data.world API

    data.world is designed for data and the people who work with data.  From professional projects to open data, data.world helps you host and share your data, collaborate with your team, and capture context and conclusions as you work.   Using this API users are able to easily access data and manage their data projects regardless of language or tool of preference.  Check out our [documentation](https://dwapi.apidocs.io) for tips on how to get started, tutorials and to interact with the API right within your browser.

    OpenAPI spec version: 0.14.1
    Contact: help@data.world
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class WebAuthorization(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'credentials': 'str'
    }

    attribute_map = {
        'type': 'type',
        'credentials': 'credentials'
    }

    def __init__(self, type=None, credentials=None):
        """
        WebAuthorization - a model defined in Swagger
        """

        self._type = None
        self._credentials = None

        self.type = type
        if credentials is not None:
          self.credentials = credentials

    @property
    def type(self):
        """
        Gets the type of this WebAuthorization.
        The authorization scheme.  Usually this is \"Bearer\" but it could be other values like \"Token\" or \"Basic\" etc.

        :return: The type of this WebAuthorization.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this WebAuthorization.
        The authorization scheme.  Usually this is \"Bearer\" but it could be other values like \"Token\" or \"Basic\" etc.

        :param type: The type of this WebAuthorization.
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")
        if type is not None and len(type) > 50:
            raise ValueError("Invalid value for `type`, length must be less than or equal to `50`")
        if type is not None and not re.search('[\\x21-\\x7E \\t]*', type):
            raise ValueError("Invalid value for `type`, must be a follow pattern or equal to `/[\\x21-\\x7E \\t]*/`")

        self._type = type

    @property
    def credentials(self):
        """
        Gets the credentials of this WebAuthorization.
        The confidential portion of the `Authorization` header that follows the `type` field.  This field is write-only. It is omitted by read operations.  If authorization is required, the `credentials` value must be provided whenever a File Source is created or modified. An update to a dataset that does not change the File Source may omit the `credentials` field--the update will preserve the previous value.

        :return: The credentials of this WebAuthorization.
        :rtype: str
        """
        return self._credentials

    @credentials.setter
    def credentials(self, credentials):
        """
        Sets the credentials of this WebAuthorization.
        The confidential portion of the `Authorization` header that follows the `type` field.  This field is write-only. It is omitted by read operations.  If authorization is required, the `credentials` value must be provided whenever a File Source is created or modified. An update to a dataset that does not change the File Source may omit the `credentials` field--the update will preserve the previous value.

        :param credentials: The credentials of this WebAuthorization.
        :type: str
        """
        if credentials is not None and len(credentials) > 1024:
            raise ValueError("Invalid value for `credentials`, length must be less than or equal to `1024`")
        if credentials is not None and len(credentials) < 1:
            raise ValueError("Invalid value for `credentials`, length must be greater than or equal to `1`")
        if credentials is not None and not re.search('[\\x21-\\x7E \\t]*', credentials):
            raise ValueError("Invalid value for `credentials`, must be a follow pattern or equal to `/[\\x21-\\x7E \\t]*/`")

        self._credentials = credentials

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, WebAuthorization):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
